"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.QueryList = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _react = _interopRequireWildcard(require("react"));
var _createStylingFromTheme = require("../styles/createStylingFromTheme");
var _rtkQuery = require("../utils/rtk-query");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
class QueryList extends _react.PureComponent {
  static isItemSelected(selectedQueryKey, queryInfo) {
    return !!selectedQueryKey && selectedQueryKey.queryKey === queryInfo.queryKey && selectedQueryKey.reducerPath === queryInfo.reducerPath;
  }
  static formatQuery(resInfo) {
    const key = resInfo.type === 'query' ? resInfo.queryKey : `${resInfo.state.endpointName ?? ''} ${resInfo.queryKey}`;
    return key;
  }
  render() {
    const {
      resInfos,
      selectedQueryKey,
      onSelectQuery
    } = this.props;
    return /*#__PURE__*/_react.default.createElement(_createStylingFromTheme.StyleUtilsContext.Consumer, null, _ref => {
      let {
        styling
      } = _ref;
      return /*#__PURE__*/_react.default.createElement("ul", styling('queryList'), resInfos.map(resInfo => {
        const isSelected = (0, _rtkQuery.isQuerySelected)(selectedQueryKey, resInfo);
        return /*#__PURE__*/_react.default.createElement("li", (0, _extends2.default)({
          key: resInfo.queryKey,
          onClick: () => onSelectQuery(resInfo)
        }, styling(['queryListItem', isSelected && 'queryListItemSelected'], isSelected)), /*#__PURE__*/_react.default.createElement("p", styling('queryListItemKey'), QueryList.formatQuery(resInfo)), /*#__PURE__*/_react.default.createElement("div", styling('queryStatusWrapper'), /*#__PURE__*/_react.default.createElement("strong", styling(['queryStatus', 'queryType']), resInfo.type === 'query' ? 'Q' : 'M'), /*#__PURE__*/_react.default.createElement("p", styling('queryStatus'), resInfo.state.status)));
      }));
    });
  }
}
exports.QueryList = QueryList;