"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.QueryPreviewActions = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _toolkit = require("@reduxjs/toolkit");
var _react = _interopRequireWildcard(require("react"));
var _types = require("../types");
var _a11y = require("../utils/a11y");
var _object = require("../utils/object");
var _TreeView = require("./TreeView");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
const keySep = ' - ';
const rootProps = {
  'aria-labelledby': (0, _a11y.renderTabPanelButtonId)(_types.QueryPreviewTabs.actions),
  id: (0, _a11y.renderTabPanelId)(_types.QueryPreviewTabs.actions),
  role: 'tabpanel'
};
class QueryPreviewActions extends _react.PureComponent {
  constructor() {
    super(...arguments);
    (0, _defineProperty2.default)(this, "selectFormattedActions", (0, _toolkit.createSelector)(_object.identity, actions => {
      const output = {};
      if (actions.length === 0) {
        return _object.emptyRecord;
      }
      for (let i = 0, len = actions.length; i < len; i++) {
        const action = actions[i];
        const key = `${i}${keySep}${action?.type ?? ''}`;
        output[key] = action;
      }
      return output;
    }));
    (0, _defineProperty2.default)(this, "isLastActionNode", (keyPath, layer) => {
      if (layer >= 1) {
        const len = this.props.actionsOfQuery.length;
        const actionKey = keyPath[keyPath.length - 1];
        if (typeof actionKey === 'string') {
          const index = Number(actionKey.split(keySep)[0]);
          return len > 0 && len - index < 2;
        }
      }
      return false;
    });
    (0, _defineProperty2.default)(this, "shouldExpandNodeInitially", (keyPath, value, layer) => {
      if (layer === 1) {
        return this.isLastActionNode(keyPath, layer);
      }
      if (layer === 2) {
        return this.isLastActionNode(keyPath, layer) && (keyPath[0] === 'meta' || keyPath[0] === 'error');
      }
      return layer <= 1;
    });
  }
  render() {
    const {
      isWideLayout,
      actionsOfQuery
    } = this.props;
    return /*#__PURE__*/_react.default.createElement(_TreeView.TreeView, {
      rootProps: rootProps,
      data: this.selectFormattedActions(actionsOfQuery),
      isWideLayout: isWideLayout,
      shouldExpandNodeInitially: this.shouldExpandNodeInitially
    });
  }
}
exports.QueryPreviewActions = QueryPreviewActions;