"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.QueryPreviewApi = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _types = require("../types");
var _createStylingFromTheme = require("../styles/createStylingFromTheme");
var _TreeView = require("./TreeView");
var _a11y = require("../utils/a11y");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
const rootProps = {
  'aria-labelledby': (0, _a11y.renderTabPanelButtonId)(_types.QueryPreviewTabs.apiConfig),
  id: (0, _a11y.renderTabPanelId)(_types.QueryPreviewTabs.apiConfig),
  role: 'tabpanel'
};
class QueryPreviewApi extends _react.PureComponent {
  constructor() {
    super(...arguments);
    (0, _defineProperty2.default)(this, "shouldExpandApiStateNode", (keyPath, value, layer) => {
      const lastKey = keyPath[keyPath.length - 1];
      return layer <= 1 && lastKey !== 'config';
    });
  }
  render() {
    const {
      apiStats,
      isWideLayout,
      apiState
    } = this.props;
    if (!apiState) {
      return null;
    }
    const hasMutations = Object.keys(apiState.mutations).length > 0;
    const hasQueries = Object.keys(apiState.queries).length > 0;
    return /*#__PURE__*/_react.default.createElement(_createStylingFromTheme.StyleUtilsContext.Consumer, null, _ref => {
      let {
        styling
      } = _ref;
      return /*#__PURE__*/_react.default.createElement("article", (0, _extends2.default)({}, rootProps, styling('tabContent')), /*#__PURE__*/_react.default.createElement("h2", null, apiState.config.reducerPath), /*#__PURE__*/_react.default.createElement(_TreeView.TreeView, {
        before: /*#__PURE__*/_react.default.createElement("h3", null, "State"),
        data: apiState,
        shouldExpandNodeInitially: this.shouldExpandApiStateNode,
        isWideLayout: isWideLayout
      }), apiStats && /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_TreeView.TreeView, {
        before: /*#__PURE__*/_react.default.createElement("h3", null, "Tally"),
        data: apiStats.tally,
        isWideLayout: isWideLayout
      }), hasQueries && /*#__PURE__*/_react.default.createElement(_TreeView.TreeView, {
        before: /*#__PURE__*/_react.default.createElement("h3", null, "Queries Timings"),
        data: apiStats.timings.queries,
        isWideLayout: isWideLayout
      }), hasMutations && /*#__PURE__*/_react.default.createElement(_TreeView.TreeView, {
        before: /*#__PURE__*/_react.default.createElement("h3", null, "Mutations Timings"),
        data: apiStats.timings.mutations,
        isWideLayout: isWideLayout
      })));
    });
  }
}
exports.QueryPreviewApi = QueryPreviewApi;