"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.QueryPreviewInfo = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _toolkit = require("@reduxjs/toolkit");
var _query = require("@reduxjs/toolkit/dist/query");
var _react = _interopRequireWildcard(require("react"));
var _types = require("../types");
var _a11y = require("../utils/a11y");
var _formatters = require("../utils/formatters");
var _object = require("../utils/object");
var _rtkQuery = require("../utils/rtk-query");
var _TreeView = require("./TreeView");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
const rootProps = {
  'aria-labelledby': (0, _a11y.renderTabPanelButtonId)(_types.QueryPreviewTabs.queryinfo),
  id: (0, _a11y.renderTabPanelId)(_types.QueryPreviewTabs.queryinfo),
  role: 'tabpanel'
};
class QueryPreviewInfo extends _react.PureComponent {
  constructor() {
    super(...arguments);
    (0, _defineProperty2.default)(this, "shouldExpandNodeInitially", (keyPath, value, layer) => {
      const lastKey = keyPath[keyPath.length - 1];
      return layer <= 1 && lastKey !== 'query' && lastKey !== 'mutation';
    });
    (0, _defineProperty2.default)(this, "selectFormattedQuery", (0, _toolkit.createSelector)(_object.identity, resInfo => {
      const {
        state,
        queryKey,
        reducerPath
      } = resInfo;
      const startedAt = state.startedTimeStamp ? new Date(state.startedTimeStamp).toISOString() : '-';
      const loadedAt = state.fulfilledTimeStamp ? new Date(state.fulfilledTimeStamp).toISOString() : '-';
      const statusFlags = (0, _rtkQuery.getQueryStatusFlags)(state);
      const timings = {
        startedAt,
        loadedAt,
        duration: '-'
      };
      if (state.fulfilledTimeStamp && state.startedTimeStamp && state.status !== _query.QueryStatus.pending && state.startedTimeStamp <= state.fulfilledTimeStamp) {
        timings.duration = (0, _formatters.formatMs)(state.fulfilledTimeStamp - state.startedTimeStamp);
      }
      if (resInfo.type === 'query') {
        return {
          key: queryKey,
          reducerPath,
          query: resInfo.state,
          statusFlags,
          timings
        };
      }
      return {
        key: queryKey,
        reducerPath,
        mutation: resInfo.state,
        statusFlags,
        timings
      };
    }));
  }
  render() {
    const {
      resInfo,
      isWideLayout
    } = this.props;
    const formattedQuery = this.selectFormattedQuery(resInfo);
    return /*#__PURE__*/_react.default.createElement(_TreeView.TreeView, {
      rootProps: rootProps,
      data: formattedQuery,
      isWideLayout: isWideLayout,
      shouldExpandNodeInitially: this.shouldExpandNodeInitially
    });
  }
}
exports.QueryPreviewInfo = QueryPreviewInfo;