"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _selectors = require("../selectors");
var _reducers = require("../reducers");
var _QueryList = require("../components/QueryList");
var _QueryForm = require("../components/QueryForm");
var _QueryPreview = require("./QueryPreview");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
class RtkQueryInspector extends _react.PureComponent {
  constructor(props) {
    super(props);
    (0, _defineProperty2.default)(this, "inspectorRef", /*#__PURE__*/(0, _react.createRef)());
    (0, _defineProperty2.default)(this, "isWideIntervalRef", null);
    (0, _defineProperty2.default)(this, "selectors", (0, _selectors.createInspectorSelectors)());
    (0, _defineProperty2.default)(this, "updateSizeMode", () => {
      if (this.inspectorRef.current) {
        const isWideLayout = this.inspectorRef.current.offsetWidth >= RtkQueryInspector.wideLayout;
        if (isWideLayout !== this.state.isWideLayout) {
          this.setState({
            isWideLayout
          });
        }
      }
    });
    (0, _defineProperty2.default)(this, "handleQueryFormValuesChange", values => {
      this.props.dispatch((0, _reducers.changeQueryFormValues)(values));
    });
    (0, _defineProperty2.default)(this, "handleSelectQuery", queryInfo => {
      this.props.dispatch((0, _reducers.selectQueryKey)(queryInfo));
    });
    (0, _defineProperty2.default)(this, "handleTabChange", tab => {
      this.props.dispatch((0, _reducers.selectedPreviewTab)(tab));
    });
    this.state = {
      isWideLayout: true,
      selectorsSource: (0, _selectors.computeSelectorSource)(props, null)
    };
  }
  static getDerivedStateFromProps(props, state) {
    const selectorsSource = (0, _selectors.computeSelectorSource)(props, state.selectorsSource);
    if (selectorsSource !== state.selectorsSource) {
      return {
        selectorsSource
      };
    }
    return null;
  }
  componentDidMount() {
    this.updateSizeMode();
    this.isWideIntervalRef = setInterval(this.updateSizeMode, 300);
  }
  componentWillUnmount() {
    if (this.isWideIntervalRef) {
      clearTimeout(this.isWideIntervalRef);
    }
  }
  render() {
    const {
      selectorsSource,
      isWideLayout
    } = this.state;
    const {
      styleUtils: {
        styling
      }
    } = this.props;
    const allVisibleRtkResourceInfos = this.selectors.selectAllVisbileQueries(selectorsSource);
    const currentResInfo = this.selectors.selectCurrentQueryInfo(selectorsSource);
    const apiStates = this.selectors.selectApiStates(selectorsSource);
    const hasNoApi = apiStates == null;
    const searchQueryRegex = this.selectors.selectSearchQueryRegex(selectorsSource);
    return /*#__PURE__*/_react.default.createElement("div", (0, _extends2.default)({
      ref: this.inspectorRef,
      "data-wide-layout": +this.state.isWideLayout
    }, styling('inspector')), /*#__PURE__*/_react.default.createElement("div", (0, _extends2.default)({}, styling('querySectionWrapper'), {
      "data-wide-layout": +this.state.isWideLayout
    }), /*#__PURE__*/_react.default.createElement(_QueryForm.QueryForm, {
      searchQueryRegex: searchQueryRegex,
      values: selectorsSource.monitorState.queryForm.values,
      onFormValuesChange: this.handleQueryFormValuesChange
    }), /*#__PURE__*/_react.default.createElement(_QueryList.QueryList, {
      onSelectQuery: this.handleSelectQuery,
      resInfos: allVisibleRtkResourceInfos,
      selectedQueryKey: selectorsSource.monitorState.selectedQueryKey
    })), /*#__PURE__*/_react.default.createElement(_QueryPreview.QueryPreview, {
      selectorsSource: this.state.selectorsSource,
      selectors: this.selectors,
      resInfo: currentResInfo,
      selectedTab: selectorsSource.monitorState.selectedPreviewTab,
      onTabChange: this.handleTabChange,
      styling: styling,
      isWideLayout: isWideLayout,
      hasNoApis: hasNoApi
    }));
  }
}
(0, _defineProperty2.default)(RtkQueryInspector, "wideLayout", 600);
var _default = RtkQueryInspector;
exports.default = _default;