"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _RtkQueryInspector = _interopRequireDefault(require("./RtkQueryInspector"));
var _reducers = require("../reducers");
var _createStylingFromTheme = require("../styles/createStylingFromTheme");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
class RtkQueryMonitor extends _react.Component {
  constructor(props) {
    super(props);
    this.state = {
      styleUtils: (0, _createStylingFromTheme.createThemeState)(props)
    };
  }
  render() {
    const {
      currentStateIndex,
      computedStates,
      monitorState,
      dispatch,
      actionsById
    } = this.props;
    return /*#__PURE__*/_react.default.createElement(_createStylingFromTheme.StyleUtilsContext.Provider, {
      value: this.state.styleUtils
    }, /*#__PURE__*/_react.default.createElement(_RtkQueryInspector.default, {
      computedStates: computedStates,
      currentStateIndex: currentStateIndex,
      monitorState: monitorState,
      dispatch: dispatch,
      styleUtils: this.state.styleUtils,
      actionsById: actionsById
    }));
  }
}
(0, _defineProperty2.default)(RtkQueryMonitor, "update", _reducers.reducer);
(0, _defineProperty2.default)(RtkQueryMonitor, "propTypes", {
  dispatch: _propTypes.default.func,
  computedStates: _propTypes.default.array,
  currentStateIndex: _propTypes.default.number,
  actionsById: _propTypes.default.object,
  stagedActionIds: _propTypes.default.array,
  skippedActionIds: _propTypes.default.array,
  monitorState: _propTypes.default.object,
  theme: _propTypes.default.oneOfType([_propTypes.default.object, _propTypes.default.string]),
  invertTheme: _propTypes.default.bool
});
(0, _defineProperty2.default)(RtkQueryMonitor, "defaultProps", {
  theme: 'nicinabox',
  invertTheme: false
});
var _default = RtkQueryMonitor;
exports.default = _default;