import _defineProperty from "@babel/runtime/helpers/defineProperty";
import React, { PureComponent } from 'react';
import { QueryPreviewTabs } from '../types';
import { renderTabPanelButtonId, renderTabPanelId } from '../utils/a11y';
import { TreeView } from './TreeView';
const rootProps = {
  'aria-labelledby': renderTabPanelButtonId(QueryPreviewTabs.data),
  id: renderTabPanelId(QueryPreviewTabs.data),
  role: 'tabpanel'
};
export class QueryPreviewData extends PureComponent {
  constructor() {
    super(...arguments);
    _defineProperty(this, "shouldExpandNodeInitially", (keyPath, value, layer) => {
      return layer <= 1;
    });
  }
  render() {
    const {
      data,
      isWideLayout
    } = this.props;
    return /*#__PURE__*/React.createElement(TreeView, {
      rootProps: rootProps,
      data: data,
      isWideLayout: isWideLayout,
      shouldExpandNodeInitially: this.shouldExpandNodeInitially
    });
  }
}