import _extends from "@babel/runtime/helpers/extends";
import React from 'react';
import { ArrowUpIcon } from './ArrowUpIcon';
import { StyleUtilsContext } from '../styles/createStylingFromTheme';
export function SortOrderButton(_ref) {
  let {
    isAsc,
    onChange,
    id
  } = _ref;
  const handleButtonClick = () => {
    if (!isAsc) {
      onChange(true);
    } else onChange(false);
  };
  const buttonLabel = isAsc ? 'asc' : 'desc';
  const arrowStyles = {
    width: '1em',
    height: '1em',
    transform: !isAsc ? 'scaleY(-1)' : undefined
  };
  return /*#__PURE__*/React.createElement(StyleUtilsContext.Consumer, null, _ref2 => {
    let {
      styling
    } = _ref2;
    return /*#__PURE__*/React.createElement("button", _extends({
      type: "button",
      id: id,
      onClick: handleButtonClick,
      "aria-pressed": isAsc
    }, styling(['sortButton'])), /*#__PURE__*/React.createElement(ArrowUpIcon, {
      style: arrowStyles
    }), buttonLabel);
  });
}